export function deepClone(source) {
	if (!source && typeof source !== 'object') {
		throw new Error('error arguments', 'deepClone')
	}
	const targetObj = source.constructor === Array ? [] : {}
	Object.keys(source).forEach(keys => {
		if (source[keys] && typeof source[keys] === 'object') {
			targetObj[keys] = deepClone(source[keys])
		} else {
			targetObj[keys] = source[keys]
		}
	})
	return targetObj
}
export function dataFilter(responseData) {
	const data = Object.keys(responseData).reduce((result, key) => {
		const item = responseData[key];
		Object.keys(item).forEach(property => {
			const index = result.findIndex(obj => obj.name === property);
			if (index === -1) {
				result.push({
					name: property,
					date: item[property] &&  [item[property]] || [0]
				});
			} else {
				result[index].date.push(item[property] || 0);
			}
		});
		return result;
	}, []);
	return data
}
//返回上月的时间
export function fmatterDate() {
	const today = new Date();
	const lastMonth = new Date(today);
	lastMonth.setMonth(lastMonth.getMonth() - 1);
	const lastMonthNumber = String(lastMonth.getMonth() + 1).padStart(2, '0');
	const lastYear = lastMonth.getFullYear();
	return `${lastYear}-${lastMonthNumber}`
}
export function formatTimestamp(timestamp) {
  const date = timestamp ? new Date(timestamp) : new Date();
  const year = date.getFullYear();
  const month = (date.getMonth() + 1).toString().padStart(2, '0');
  const day = date.getDate().toString().padStart(2, '0');
  const hours = date.getHours().toString().padStart(2, '0');
  const minutes = date.getMinutes().toString().padStart(2, '0');
  const seconds = date.getSeconds().toString().padStart(2, '0');
  return `${year}-${month}-${day} ${hours}:${minutes}:${seconds}`;
}

//防抖
export function debounce(func, delay) {
  let timeoutId;
  return function() {
    const context = this;
    const args = arguments;
    clearTimeout(timeoutId);
    timeoutId = setTimeout(function() {
      func.apply(context, args);
    }, delay);
  };
}
// 校验失败滚动到对应的错误位置
export function elFormErrorScrollIntoView() {
  // 获取第一个校验错误的元素
  const element = document.querySelectorAll('.msg--active')[0]
  // 滚动到错误元素对应位置
  element.scrollIntoView({
    behavior: 'smooth',
    block: 'center'
  })
}
